<%

' ASP Code Created By: Brian Taylor
' email: littlemojo@planetquake.com

on error resume next
%>

<HTML>
<head>
<title>BQServer Test</title>
</head>

<BODY background="images/darkbluebg.gif" bgcolor="#00125B" topmargin="0" leftmargin="0" text="#FFFFFF" vlink="#FFFFFF" alink="#FFFFFF">

<CENTER>

<%
	dim QxBrowser, hostIP, hostPort, Password, mapname, fraglimit
	dim timelimit, hostname, maxclients, Server_Return, temper

	set QxBrowser = Server.CreateObject("BQServer.Quake")


' This Function adds font tags to the colors in the name

	Function Cleanup(CleanedUser)

		CleanedUser = Replace(CleanedUser,"^0","<Font color=black>")
		CleanedUser = Replace(CleanedUser,"^1","<Font color=red>")
		CleanedUser = Replace(CleanedUser,"^2","<Font color=green>")
		CleanedUser = Replace(CleanedUser,"^3","<Font color=yellow>")
		CleanedUser = Replace(CleanedUser,"^4","<Font color=blue>")
		CleanedUser = Replace(CleanedUser,"^5","<Font color=cyan>")
		CleanedUser = Replace(CleanedUser,"^6","<Font color=magenta>")
		CleanedUser = Replace(CleanedUser,"^7","<Font color=white>")

		CleanedUser = Replace(CleanedUser,"<Font color=","</FONT><Font color=")


		CleanedUser = CleanedUser & "</FONT>"

		CleanedUser = Replace(CleanedUser,"</FONT>","", 1, 1)

		Cleanup = CleanedUser

	End Function


' You Must Enter a Real IP, Port, and Rcon Password for this to work

	hostIP = "192.168.123.35"
	hostPort = "27960"
	Password = "homer1"
	SVTimeOut = 4
	SVDelay = 0.51


' This condition checks to see if the server exists

	temper = QxBrowser.Server_Rcon("mapname", hostIP, hostPort, Password, 4)

	if temper = "BQServer Error: Server Timed Out" then
		response.write "<BR><FONT SIZE=1>" & Now() & "</FONT><BR><IMG SRC='images/bqserverlogo.gif'><BR><FONT FACE='ARIAL'>The Quake3 server is currently down... Please try again later."
		response.write "</BODY></HTML>"
		response.end
	end if



' These temp files contain the raw returned strings from the server

	mapname = QxBrowser.Server_Rcon("mapname", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	fraglimit = QxBrowser.Server_Rcon("fraglimit", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	timelimit = QxBrowser.Server_Rcon("timelimit", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	sv_hostname = QxBrowser.Server_Rcon("sv_hostname", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	sv_maxclients = QxBrowser.Server_Rcon("sv_maxclients", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	g_gametype = QxBrowser.Server_Rcon("g_gametype", hostIP, hostPort, Password, SVTimeOut, SVDelay)
	Server_Return = QxBrowser.Server_Rcon("status", hostIP, hostPort, Password, SVTimeOut, SVDelay)


' The temp files are then cleaned up, and only the needed data is left.

	mapname = Mid(mapname, 15, Len(mapname)-37)
	fraglimit = Mid(fraglimit, 17, Len(fraglimit)-36)
	timelimit = Mid(timelimit, 17, Len(timelimit)-35)
	sv_hostname = Mid(sv_hostname, 19, Len(sv_hostname)-42)
	sv_maxclients = Mid(sv_maxclients, 21, Len(sv_maxclients)-39)


' This chooses the friendly name for the Quake3 game types

	g_gametype = Mid(g_gametype, 18, Len(g_gametype)-36)

	Select Case g_gametype
		Case "0"
			g_gametype = "Free For All"
		Case "1"
			g_gametype = "Tournament 1-on-1"
		Case "2"
			g_gametype = "Single-Player"
		Case "3"
			g_gametype = "Team Deathmatch"
		Case "4"
			g_gametype = "Capture the Flag"
	End Select




' This removes the first 3 lines of the Server_Return data containing "status"

	LeftCount = (Instr(1, Server_Return, "---------------------", 1))+33

	Server_Return_Trim = Right(Server_Return, (Len(Server_Return)-LeftCount))

	Server_Return_Trim = Left(Server_Return_Trim, Len(Server_Return_Trim)-2)



' This counts the players connected by counting the number of charaters in the string. A Half assed approach indeed.

	PlayersOn = Int(Len(Server_Return_Trim)/73)



' This is an example of how to change the server's TimeLimit (commented out of execution)

'	s_timelimit = 18
'	temp = QxBrowser.Server_Rcon("timelimit " & s_timelimit, hostIP, hostPort, Password, SVTimeOut)

%>




	<Font Size=2><B>Quake 3</B> Server Data Gathered: <%=Now()%></FONT>

	<BR><BR>

<TABLE border=0 width=460>
<TR><TD>
<CENTER>
	<Font Size=5 Face="Impact"><%=Cleanup(sv_hostname)%></FONT>

	<BR>

	<Font size=2 Face='Arial'>

	IP: <B><%=hostIP%></B>

	<BR><BR>

	<B>- <%=g_gametype%> -</B>

	<BR>

	<B><%=mapname%></B>

	<BR>

	<IMG SRC="quake3/baseq3/images/<%=mapname%>.jpg" border=1 width="128" height="100">

	<BR>

	TimeLimit: <B><%=timelimit%></B>

	<BR>

	FragLimit: <B><%=fraglimit%></B>

	<BR>

	Max Clients: <B><%=sv_maxclients%></B>

	<BR>

	</FONT>

</TD>
<TD>
<CENTER>

	<TABLE width=210 border=1 cellspacing=0 cellpadding=2 bordercolor="#526096">
	<TR><TD width="90%" bgcolor="#334071"><Font size=2 Face='Arial'><B>Players: <%=PlayersOn%></B></TD><TD width="10%" bgcolor="#334071"><Font size=2 Face='Arial'><B>Score</B></TD></TR>
	

<%

' This generate the player names and scores from Server_Return_Trim

	LastTrim = 1

	Trims = 1

	While Trims <> 0

		StartTrim = StartTrim + 74

		Trims = Instr(StartTrim, Server_Return_Trim, Chr(10))


		if Trims <> 0 then


			TrimTemp = Mid(Server_Return_Trim, LastTrim, (Trims-LastTrim)-1)

			UserName = Trim(Mid(TrimTemp, 17, 16+((Trims-LastTrim)-74)))


			Score = Trim(Mid(TrimTemp, 6, 5))


			response.write "<TR><TD bgcolor='#00104F'><Font size=1 Face='Arial'><B>" & Cleanup(UserName) & "<B></FONT></TD><TD bgcolor='#00104F' align=center><Font Face='Arial' Size=1>" &  Score & "</FONT></TD></TR>"

			LastTrim = Trims


		end if

	wend
%>

	</TR>
	</TABLE>



</TD>
</TR>
</TABLE>

<BR>
<hr noshade color="#526096" size="1">
<BR>

	<TABLE border=1 cellspacing=0 cellpadding=6 bordercolor="#526096"><TR><TD bgcolor="#334071">
	<FONT SIZE=2>
	<PRE><%=QxBrowser.Server_Rcon("status", hostIP, hostPort, Password, SVTimeOut, SVDelay)%></PRE>
	</TD></TR></TABLE>

<BR>
	<TABLE border=1 cellspacing=0 cellpadding=6 bordercolor="#526096"><TR><TD bgcolor="#334071">
	<FONT SIZE=2>
	<PRE><%=QxBrowser.Server_Rcon("serverinfo", hostIP, hostPort, Password, SVTimeOut, SVDelay)%></PRE>
	</FONT>
	</TD></TR></TABLE>


<BR><BR>
<A HREF="http://www.planetquake.com/bqserver" target="_blank"><IMG SRC="images/bqserverlogo.gif" border="0"></A>
<BR>
<FONT size="1" face="Arial">
Please visit the <A HREF="http://www.planetquake.com/bqserver" target="_blank">BQServer Web Site</A> if you have any questions.
</FONT>
<BR>
<FONT size="1" face="Arial">BQServer was developed by Brian Taylor 2001, for non-commercial uses. All rights reserved.</FONT>


</BODY>
</HTML>