<%
' ASP Code Created By: Brian Taylor
' email: littlemojo@planetquake.com
%>
<%
on error resume next

' Check to see if the session has expired

	if session("IP") = "" then
		Response.Redirect("../default.asp")
		response.end
	end if
%>

<%
	dim BQServer, quakemap, MyConn, hostIP, hostPort
	dim gamename, mapname, fraglimit, timelimit, sv_hostname
	dim g_gametype, capturelimit, sv_allowdownload, g_teamForceBalance, g_friendlyfire, g_password

%>

<HTML>

<head>
	<title>Quake III</title>
</head>

<BODY background="../images/lightbluebg.gif" bgcolor="#003366" topmargin="5" leftmargin="5" text="#FFFFFF" link="#44BBFF" vlink="#44BBFF" alink="#44BBFF">

<%

' This Function adds font tags to the colors in the name.

	Function Cleanup(CleanedUser)

		CleanedUser = Replace(CleanedUser,"^0","<Font color='black'>")
		CleanedUser = Replace(CleanedUser,"^1","<Font color='red'>")
		CleanedUser = Replace(CleanedUser,"^2","<Font color='#00DD00'>")
		CleanedUser = Replace(CleanedUser,"^3","<Font color='yellow'>")
		CleanedUser = Replace(CleanedUser,"^4","<Font color='#3333FF'>")
		CleanedUser = Replace(CleanedUser,"^5","<Font color='cyan'>")
		CleanedUser = Replace(CleanedUser,"^6","<Font color='magenta'>")
		CleanedUser = Replace(CleanedUser,"^7","<Font color='white'>")

		CleanedUser = Replace(CleanedUser,"<Font color=","</FONT><Font color=")


		CleanedUser = CleanedUser & "</FONT>"

		CleanedUser = Replace(CleanedUser,"</FONT>","", 1, 1)

		Cleanup = CleanedUser

	End Function


' This Function removes everything but the player name

	Function CleanupNoColor(CleanedUser2)

		CleanedUser2 = Replace(CleanedUser2,"^0","")
		CleanedUser2 = Replace(CleanedUser2,"^1","")
		CleanedUser2 = Replace(CleanedUser2,"^2","")
		CleanedUser2 = Replace(CleanedUser2,"^3","")
		CleanedUser2 = Replace(CleanedUser2,"^4","")
		CleanedUser2 = Replace(CleanedUser2,"^5","")
		CleanedUser2 = Replace(CleanedUser2,"^6","")
		CleanedUser2 = Replace(CleanedUser2,"^7","")

		CleanupNoColor = CleanedUser2

	End Function



' This Function checks to see if the server exists

	Function ServerTimeOut(Message)
	
		if Message = "BQServer Error: Server Timed Out" then
			response.write "<CENTER><BR><FONT SIZE=1>" & Now() & "</FONT><BR><IMG SRC='../images/bqserverlogo.gif'><BR><FONT size=2 FACE='ARIAL'>The Quake3 server is currently down... Please try again later."
			response.write "<BR><BR>Also, the Quake server may have been too overloaded with messages.<BR>Please try not to refresh your browser too fast."
			response.write "</BODY></HTML>"
			ServerTimeOut = "BQServer Error: Server Timed Out"
			response.end
		else
			ServerTimeOut = Message
		end if
		
	End Function


' Open server connection to the BQServer DLL

	set BQServer = Server.CreateObject("BQServer.Quake")


' Session variables created in 'quakesession.asp' when you loged in

	hostIP = session("IP")
	hostPort = session("Port")
	Password = session("Password")
	SVTimeOut = 5  'Important: This is the amount of time(in seconds) that the dll waits to hear something back from the Quake server.
	SVDelay = 0.5

' This Function can pull multiple server variables from one server message "serverinfo"
' This was done to lessen the number of messages sent to the quake3 server

' Variables available are:
'	g_needpass, gamename, bot_minplayers, sv_allowdownload, sv_privateClients, mapname
'	protocol, g_gamename, version, g_maxGameClients, capturelimit, sv_floodProtect, sv_maxRate
'	sv_maxclients, sv_hostname, timelimit, fraglimit, dmflags, sv_minPing, sv_maxPing

	Private Function F_ServerInfo(LookUp)
	
		F_ServerInfo_Result1 = Instr(1, serverinfo, LookUp, 1)
		F_ServerInfo_Result2 = Instr(F_ServerInfo_Result1, serverinfo, Chr(10), 1)
		F_ServerInfo = Mid(serverinfo, (F_ServerInfo_Result1 + 20), ((F_ServerInfo_Result2 - 1) - (F_ServerInfo_Result1 + 20)))
	
	End Function


' This Function finds out what a player's team is.
' However, then I found out that this only works for bots, and not players, which is totally ID Software's fault.
' "dumpuser" returns different info for bots than players. The player info does not contain the team they are on. Very dumb!
' I'm trying to work something out. 

	Function UserTeam(UserName)

		PlayerInfo = BQServer.Server_Rcon("dumpuser " & UserName, hostIP, hostPort, Password, SVTimeOut, SVDelay)
		CountIn = (Instr(1, PlayerInfo, "team                ", 1))
		CountBack = Instr(CountIn, PlayerInfo, Chr(10))
		PlayerInfo = Mid(PlayerInfo, CountIn+20, (CountBack-CountIn)-21)

		UserTeam = LCase(PlayerInfo)

	End Function


' Here, all of the needed info from the Quake3 server is retrived by sending messages through bqserver

	serverinfo = ServerTimeOut(BQServer.Server_Rcon("serverinfo", hostIP, hostPort, Password, SVTimeOut, SVDelay))
	Server_Return = ServerTimeOut(BQServer.Server_Rcon("status", hostIP, hostPort, Password, SVTimeOut, SVDelay))


	if session("g_teamForceBalance") = "" or request.querystring("refresh") = "full" then
		g_teamForceBalance = ServerTimeOut(BQServer.Server_Rcon("g_teamForceBalance", hostIP, hostPort, Password, SVTimeOut, SVDelay))
		session("g_teamForceBalance") = g_teamForceBalance
	else
		g_teamForceBalance = session("g_teamForceBalance")
	end if

	if session("g_friendlyfire") = "" or request.querystring("refresh") = "full" then
		g_friendlyfire = ServerTimeOut(BQServer.Server_Rcon("g_friendlyfire", hostIP, hostPort, Password, SVTimeOut, SVDelay))
		session("g_friendlyfire") = g_friendlyfire
	else
		g_friendlyfire = session("g_friendlyfire")
	end if

	if session("fs_game") = "" or request.querystring("refresh") = "full" then
		fs_game = ServerTimeOut(BQServer.Server_Rcon("fs_game", hostIP, hostPort, Password, SVTimeOut, SVDelay))
		session("fs_game") = fs_game
	else
		fs_game = session("fs_game")
	end if
	


' This cleans up the data that is returned from the Quake3 Server

	gamename = F_ServerInfo("gamename")
	mapname = F_ServerInfo("mapname")
	fraglimit = F_ServerInfo("fraglimit           ")
	timelimit = F_ServerInfo("timelimit           ")
	sv_hostname = F_ServerInfo("sv_hostname")
	sv_maxclients = F_ServerInfo("sv_maxclients")
	g_gametype = F_ServerInfo("g_gametype")
	capturelimit = F_ServerInfo("capturelimit")
	sv_allowdownload = F_ServerInfo("sv_allowdownload")
	version = F_ServerInfo("version             ")
	
	g_teamForceBalance = Mid(g_teamForceBalance, 26, Len(g_teamForceBalance)-44)
	


	'g_friendlyfire = Mid(g_friendlyfire, 22, Len(g_friendlyfire)-40)
	
	g_friendlyfire = Left(g_friendlyfire,InStr(g_friendlyfire,"default")-5)
	g_friendlyfire = Right(g_friendlyfire,Len(g_friendlyfire)-InStr(g_friendlyfire," is:")-4)
	
	fs_game = Mid(fs_game, 15, Instr(1,fs_game,"default")-19)


' Open server connection to the map database

	Set MyConn = Server.CreateObject("ADODB.Connection")
	MdbFilePath = Server.MapPath("baseq3/quakemaps.mdb")
	MyConn.Open "Driver={Microsoft Access Driver (*.mdb)}; DBQ=" & MdbFilePath & ";"


' This chooses the friendly name for the Quake3 game types

	Select Case g_gametype
		Case "0"
			g_gametype_name = "Free For All"
			gametype = "?gametype=DMTM"
			gametype_add = "gametype='DM' or gametype='TM' and"
		Case "1"
			g_gametype_name = "Tournament 1-on-1"
			gametype = "?gametype=TM"
			gametype_add = "gametype='DM' or gametype='TM' and"
			
		Case "2"
			g_gametype_name = "Single-Player"
			gametype = ""
			gametype_add = "gametype='DM' or gametype='TM' or gametype='CTF' and"
			
		Case "3"
			g_gametype_name = "Team Deathmatch"
			gametype = "?gametype=DMTM"
			gametype_add = "gametype='DM' or gametype='TM' and"
			
		Case "4"
			g_gametype_name = "Capture the Flag"
			gametype = "?gametype=CTF"
			gametype_add = "gametype='CTF' and"
			
	End Select

if NOT gamename = "baseq3" then

	gametype = "?gametype=mod"
	gametype_add = "gametype='" & fs_game & "' and"

end if

gametype_add = ""


' This selects all of the map info from the database that is flagged to be shown

	Set OS = MyConn.Execute("SELECT mapQName, mapName, gametype FROM QUAKE3MAPS WHERE show=1 order By gametype, mapName")



' This removes the first 3 lines of the Server_Return data containing server "status"

	LeftCount = (Instr(1, Server_Return, "---------------------", 1))+33

	Server_Return_Trim = Right(Server_Return, (Len(Server_Return)-LeftCount))

	Server_Return_Trim = Left(Server_Return_Trim, Len(Server_Return_Trim)-2)



' This counts the players connected by counting the number of charaters in the string. A half-assed approach indeed, but its close enough.

	PlayersOn = Int(Len(Server_Return_Trim)/73) 'The result is just rounded off my converting it to and integer. So now its whole-assed.



' This takes care of the Auto Refresh feature.

	Select Case session("AutoRefresh")
		Case ""
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=30'>Off</A>"
		Case "0"
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=30'>Off</A>"
		Case "30"
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=60'>30sec</A>"
			response.write "<META HTTP-EQUIV='REFRESH' CONTENT='30; URL=bqserver_quake3.asp'>"
		Case "60"
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=120'>60sec</A>"
			response.write "<META HTTP-EQUIV='REFRESH' CONTENT='60; URL=bqserver_quake3.asp'>"
		Case "120"
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=240'>120sec</A>"
			response.write "<META HTTP-EQUIV='REFRESH' CONTENT='120; URL=bqserver_quake3.asp'>"
		Case "240"
			AutoRefreshHTML = "<A HREF='update_quake3.asp?AutoRefresh=0'>240sec</A>"
			response.write "<META HTTP-EQUIV='REFRESH' CONTENT='240; URL=bqserver_quake3.asp'>"
	End Select


%>

<script language="javascript">
<!--

	window.name = "Quake3Main"


	function OpenWindow(Link){

	var remote = null;

	remote = window.open('','QuakeWindow','height=350,width=500,toolbar=no,directories=no,menubar=no,scrollbars=yes,resizable=no');
	remote.opener = self

	remote.location.href = Link

	}

	function InfoWindow(Link){

	var remote = null;

	remote = window.open('','QuakeWindow','height=265,width=410,toolbar=no,directories=no,menubar=no,scrollbars=no,resizable=no');
	remote.opener = self

	remote.location.href = Link

	}


	function KickCheck(KickLink,PlayerName){
	var joe
	joe = confirm("Are you really sure you want to kick " + PlayerName + "?")
	
		if (joe == 1){
			self.window.open(KickLink,'_self')
		}
	}


	function LogOff(Page){
	var joe
	joe = confirm("Are you really sure you want to Log Off?")
	
		if (joe == 1){
			self.window.open(Page,'_self')
		}
	}

-->
</script>

<form method="POST" action="update_quake3.asp">
<center>

<TABLE border="0" cellspacing="0" cellpadding="0">
<TR><TD align="center"><FONT size=5 face="Impact, Arial"><%=Cleanup(sv_hostname)%></FONT><BR></TD></TR>
<TR><TD align="right">

	<TABLE border="0" width="100%" cellspacing="0" cellpadding="0">
		<TR>
		<TD width="97%" align="center">

<FONT size=1 face="Arial">Quake 3 Server&nbsp;-&nbsp;IP:<%=hostIP & ":" & hostport%>&nbsp;-&nbsp;Game:<%=fs_game%></TD>

		<TD width="1%" valign="bottom"><A HREF="bqserver_quake3.asp"><IMG SRC="../images/refresh_left.gif" border="0"></A></TD>
		<TD width="1%" valign="bottom"><A HREF="bqserver_quake3.asp?refresh=full"><IMG SRC="../images/refresh_full.gif" border="0"></A></TD>
		<TD><IMG SRC="../images/spacer.gif" width="2" height="5"></TD>
		<TD width="1%" valign="bottom"><A HREF="http://www.planetquake.com/bqserver/support.htm" target="_blank"><IMG SRC="../images/help.gif" border="0"></A></TD>
		<TD><IMG SRC="../images/spacer.gif" width="2" height="5"></TD>
		<TD width="1%" valign="bottom"><a href="JavaScript:LogOff('../default.asp?r=<%=Int(((1000.9 - Timer + 1) * Rnd + Timer) *1000)%>')"><IMG SRC="../images/logoff_new.gif" border="0"></A></TD>
		</TR>
	</TABLE>
</TD></TR>

<TR><TD>
<TABLE width="600" border="1" bordercolor="#004182" cellspacing="0" cellpadding="2">

<TR>
<TD bgcolor="#0052A4" width=60%><FONT size="2" face="Arial"><B>Current Status</B></FONT>&nbsp;&nbsp;<FONT size=1 face="Arial">(Last Updated: <%=Time()%>)</FONT></TD>
<TD bgcolor="#0052A4" width=40%><FONT size="2" face="Arial"><B>Administration</B></FONT></TD>
</TR>

<TR><TD width="55%" valign="top" bgcolor="#003366">
<TABLE border="0" width="100%"><TR><TD width="50%" valign="top">


<TABLE width="132" border="1" bordercolor="#004182" cellspacing="0" cellpadding="0">
<TR><TD bgcolor="#0052A4"><center><FONT size=1 face="Arial">-Current Map-</FONT></TD></TR>
<TR><TD><CENTER>
<%

	response.write "<IMG SRC='" & "baseq3/images/" & mapname & ".jpg' border=0 width=128 height=100 alt='Image may not be available'><BR>"
%>
</TD></TR>
<TR><TD bgcolor="#00104F"><CENTER>
<FONT size=1 face="Arial">
<%

	Set RS = MyConn.Execute("SELECT mapName FROM QUAKE3MAPS WHERE mapQName='" & mapname & "'")

	if NOT RS.EOF then
		response.write RS("mapName")
	else
		response.write mapname
	end if

%>
</FONT>
</TD></TR></TABLE>

</TD><TD align="center" valign="top" width="50%">

<% ' --------Begin Player Info-------- %>

<%


%>

	<TABLE width=210 border=1 cellspacing=0 cellpadding=1 bordercolor="#004182">
	<TR><TD width="80%" bgcolor="#0052A4"><Font size=1 Face='Arial'>Players <%=PlayersOn%>/<%=sv_maxclients%></TD>
	<TD width="10%" bgcolor="#0052A4"><Font size=1 Face='Arial'>Score</TD>
	<TD width="10%" bgcolor="#0052A4"><Font size=1 Face='Arial'>Info</TD>
	<TD width="10%" bgcolor="#0052A4"><Font size=1 Face='Arial'>Kick</TD></TR>
	



<%

' This generate the player names and scores from Server_Return_Trim

	LastTrim = 1
	Trims = 1

	While Trims <> 0

		StartTrim = StartTrim + 74

		Trims = Instr(StartTrim, Server_Return_Trim, Chr(10))


		if Trims <> 0 then

		' This extracts one line
			TrimTemp = Mid(Server_Return_Trim, LastTrim, (Trims-LastTrim)-1)

			UserName = Trim(Mid(TrimTemp, 17, 16+((Trims-LastTrim)-74)))

			UserName2 = UserName

			UserNumber = Int(Trim(Mid(TrimTemp, 1, 4)))
			
			IPAddress = Trim(Mid(TrimTemp, 41+((Trims-LastTrim)-74), 16))
			
		' Checks to see if there is an IP address for the player. If not, then its a bot. Another half-assed solution.
			if IPAddress = "bot" then
				BotCheck = "<img src='../images/bot.gif'>"
			else
				BotCheck = "<img src='../images/player.gif'>"
			end if


			Score = Trim(Mid(TrimTemp, 6, 5))

			tempcount=tempcount + 1

			response.write "<TR><TD><TABLE border=0 cellspacing=0 cellpadding=0><TR><TD>" & BotCheck & "</TD><TD><Font size=1 Face='Arial'>&nbsp;" & Cleanup(UserName) & "</FONT></TD></TR></TABLE></TD>"

			response.write "<TD align=center><Font Face='Arial' Size=1>" &  Score & "</FONT></TD>"
			
			response.write "<TD align=center>"
			response.write "<A HREF=" & Chr(34) & "JavaScript:InfoWindow('q3playerinfo.asp?" & "&Random=" & Int((10000 - Timer + 1) * Rnd + Timer) & "&UserName=" & Replace(CleanupNoColor(UserName2)," ","%20") & "')" & Chr(34) & ">"
			response.write "<IMG SRC='../images/info.gif' border=0></TD>"
			
			response.write "<TD align=center><Font Face='Arial' Size=1>"
			response.write "<A HREF=" & Chr(34) & "JavaScript:KickCheck('update_quake3.asp?" & "&Random=" & Int((10000 - Timer + 1) * Rnd + Timer) & "&ClientKick=" & UserNumber & "&UserName=" & CleanupNoColor(UserName2) & "','" & CleanupNoColor(UserName2) & "')" & Chr(34) & ">"
			response.write "<IMG SRC='../images/kick.gif' border=0></FONT></A></TD></TR>"

			LastTrim = Trims
		end if

	wend

%>

</TD></TR>
<TR><TD colspan="4" bgcolor="#00104F"><CENTER>

<table border="0" width="90" cellspacing="0" cellpadding="0">
  <tr>
    <td width="2%"><img border="0" src="../images/player.gif"></td>
    <td width="59%"><font face="Arial" size="1" color="#FFFFFF">&nbsp;Human</font></td>
    <td width="2%"><font color="#FFFFFF"><img border="0" src="../images/bot.gif"></font></td>
    <td width="37%"><font face="Arial" size="1" color="#FFFFFF">&nbsp;Bot</font></td>
  </tr>
</table>

</TD></TR></TABLE>


</TD></TR></TABLE>



<% ' --------End Player Info-------- %>



<BR>


<% ' --------Begin Bots-------- %>

<TABLE width="100%" border="1" bordercolor="#004182" cellspacing="0" cellpadding="1">

</FORM><form method="POST" action="update_quake3.asp">

<TR><TD bgcolor="#0052A4"><FONT size="2" face="Arial"><B>Add Bots</B></FONT>
</TD></TR>


<TR><TD bgcolor="#003366" align="center">
<table width="80%" border=0 cellspacing="1" cellpadding="0">
<TR>
<TD><FONT size="1" face="Arial">Bot</FONT></TD><TD><FONT size="1" face="Arial">Skill</FONT></TD><TD><FONT size="1" face="Arial">Team</FONT></TD><TD><FONT size="1" face="Arial"></FONT></TD>
</TR>

<TR><TD>

<select size="1" name="BotName">
<option value="-1">---(bots)---</option>

<%

	if NOT gamename = "baseq3" then
		Set YS = MyConn.Execute("SELECT Count(gamename) as count FROM QUAKE3BOTS where gamename='" & fs_game & "'")
		if YS("count") > 0 then
			Set QS = MyConn.Execute("SELECT BotName FROM QUAKE3BOTS where gamename='" & fs_game & "' Order by BotName")
		else
			Set QS = MyConn.Execute("SELECT BotName FROM QUAKE3BOTS where gamename='baseq3' Order by BotName")
		end if
	else
		Set QS = MyConn.Execute("SELECT BotName FROM QUAKE3BOTS where gamename='baseq3' Order by BotName")
	end if

	While NOT QS.EOF
		response.write "<option value='" & QS("BotName") & "'>" & QS("BotName") & "</option>"

	QS.MoveNext
	WEND

%>
</select>

</TD><TD>
<select size="1" name="BotSkill">
    <option value="1">I Can Win</option>
    <option value="2">Bring It On</option>
    <option value="3" selected>Hurt Me Plenty</option>
    <option value="4">Hard Core</option>
    <option value="5">Nightmare!</option>
</select>
</TD>

<TD>
<select size="1" name="BotTeam">
    <option value="auto">-auto-</option>
    <option value="Blue">Blue</option>
    <option value="Red">Red</option>
</select>
</TD>

<TD><input type="submit" Name="AddBot" value="Add Bot" tabindex="1"></TD>

</TR>
</FORM>
</TABLE>
</TD></tr>
</table>


<% ' ---------End Bots--------- %>


<BR>


<% ' ---------Begin Server Command--------- %>


<TABLE width="100%" border="1" bordercolor="#004182" cellspacing="0" cellpadding="2">

<form name="joe2" method="POST" action="update_quake3.asp">

<TR><TD bgcolor="#0052A4"><FONT size="2" face="Arial"><B>Send Server Commands</B> <FONT Size="1">(advanced)</FONT></FONT></TD>
</TR>
<TR><TD align="center" bgcolor="#003366">
<CENTER>
<TABLE width="96%" border="0" cellspacing="0" cellpadding="0"><TR><TD align="center">
  <select size="1" name="command_add">
    <option value="">--(commands)--</option>

<%

	Set Commands = MyConn.Execute("SELECT CommandName, CommandValue FROM QUAKE3COMMANDS WHERE Show=1 order By CommandName")

    while NOT Commands.EOF
    
		Response.Write "<option value='" & Commands("CommandValue") & "'>" & Commands("CommandName") & "</option>"
    
		Commands.MoveNext
    WEND
    
%>

  </select>
</TD><TD align="center"><input type="text" name="command" size="22"></TD><TD align="center"><input type="submit" Name="C" value="Send"></TD></TR></TABLE></TD>
</TR>
</FORM>
</TABLE>


<% ' ---------End Server Command--------- %>


<BR>


<% ' ---------Begin Mod Admin --------- %>

<%

if NOT gamename = "baseq3" then


	Set ModS = MyConn.Execute("SELECT * FROM QUAKE3MOD WHERE ModName='" & fs_game & "' and Not FormElement='DropDown' order By SettingGroup,FormElement,SettingDesc")

%>

<form method="POST" action="update_quake3.asp" id=form1 name=form1>

<INPUT TYPE="HIDDEN" NAME="fs_game" value="<%=fs_game%>">

<TABLE width="100%" border="1" bordercolor="#004182" cellspacing="0" cellpadding="2">

<TR><TD bgcolor="#0052A4"><FONT size="2" face="Arial"><B><%=gamename%></B></FONT></TD>
</TR>
<TR><TD align="center" bgcolor="#003366">
<table border="0" width="100%"><tr><td valign='top' width='1%'>
<IMG SRC="baseq3/images/mods/mod_<%=fs_game%>.jpg"></TD>

<TD><CENTER>


<%

	Function ModFormElement(FormElement,SettingName)

		if FormElement = "CheckBox" then
			if ModSetting = "1" then
				ModValue = "CHECKED"
			else
				ModValue = ""
			end if
			
			ModFormElement = "<input type='checkbox' value='1' name='" & SettingName & "' " & ModValue & ">"
			'ModFormElement = ModFormElement & "<INPUT TYPE='HIDDEN' NAME='" & SettingName & "' value='" & ModSetting & "'>" & Chr(10)
		end if
	
	
		if FormElement = "TextBoxBig" then
			ModFormElement = "<input type='text' name='" & SettingName & "' value='" & ModSetting & "' size='16'>"
			'ModFormElement = ModFormElement & "<INPUT TYPE='HIDDEN' NAME='" & SettingName & "' value='" & ModSetting & "'>" & Chr(10)
		end if
	
		if FormElement = "TextBoxSmall" then
			ModFormElement = "<input type='text' name='" & SettingName & "' value='" & ModSetting & "' size='2'>"
			'ModFormElement = ModFormElement & "<INPUT TYPE='HIDDEN' NAME='" & SettingName & "' value='" & ModSetting & "'>" & Chr(10)
		end if
		
		if FormElement = "PasswordBox" then
			ModFormElement = "<input type='password' name='" & SettingName & "' value='" & ModSetting & "' size='9'>"
			'ModFormElement = ModFormElement & "<INPUT TYPE='HIDDEN' NAME='" & SettingName & "' value='" & ModSetting & "'>" & Chr(10)
		end if
		
		if FormElement = "WebLink" then
			ModFormElement = "<FONT size='1' face='Arial'><A HREF='" & ModS("SettingValue") & "' target='_blank'>" & ModS("SettingName") & "</A></FONT>"
		end if
		
	End Function




	response.write "<TABLE border='0' cellspacing='0' cellpadding='0'>"
	
	ModLoopCount = 0

	while NOT ModS.EOF
	
		ModLoopCount = ModLoopCount + 1
		

		if NOT ModS("FormElement") = "WebLink" then
			
		if session(ModS("SettingName")) = "" or request.querystring("refresh") = "full" then
			ModSetting = BQServer.Server_Rcon(ModS("SettingName"), hostIP, hostPort, Password, SVTimeOut, SVDelay)
			session(ModS("SettingName")) = ModSetting
		else
			ModSetting = session(ModS("SettingName"))
		end if
			ModSetting = Left(ModSetting,InStr(ModSetting,"default")-5)
			ModSetting = Right(ModSetting,Len(ModSetting)-InStr(ModSetting," is:")-4)
		end if
		
		
		response.write "<TR><TD align='right'><FONT size='1' face='Arial'>" & ModS("SettingDesc") & ":&nbsp;</FONT></TD><TD>" & ModFormElement(ModS("FormElement"),ModS("SettingName"))
		response.write "</TD></TR>"
	
		ModS.MoveNext
	WEND
	
	
	
' Drop Down Lists
	
	Set ModS = MyConn.Execute("SELECT * FROM QUAKE3MOD WHERE ModName='" & fs_game & "' and FormElement='DropDown' order By SettingGroup,SettingValue")

		countr = 0
				
		while NOT ModS.EOF
		
		ModLoopCount = ModLoopCount + 1
		
		if NOT ModS("SettingGroup") = tempr then 
		
			if countr > 0 then
				response.write "</select></TD></TR>" & Chr(10)
			end if
			
			countr = countr + 1
			
			response.write "<TR><TD align='right'><FONT size='1' face='Arial'>" & ModS("SettingGroup") & ":&nbsp;</FONT></TD>"
			response.write "<TD><select size='1' name='" & ModS("SettingName") & "'>" & Chr(10)

		if session(ModS("SettingName")) = "" or request.querystring("refresh") = "full" then
			ModSetting = BQServer.Server_Rcon(ModS("SettingName"), hostIP, hostPort, Password, SVTimeOut, SVDelay)
			session(ModS("SettingName")) = ModSetting
		else
			ModSetting = session(ModS("SettingName"))
		end if


			ModSetting = Left(ModSetting,InStr(ModSetting,"default")-5)
			ModSetting = Right(ModSetting,Len(ModSetting)-InStr(ModSetting," is:")-4)
		
		end if
			
			response.write "<option value='" & ModS("SettingValue") & "'"
			
			if ModSetting = ModS("SettingValue") then
				Response.Write " selected"
			end if
			
			Response.Write ">" & ModS("SettingDesc") & "</option>" & Chr(10)
			
			tempr = ModS("SettingGroup")
			
			ModS.MoveNext
			
		WEND
		
	
	
	
	
	Response.Write "</TABLE>"
	
		if ModLoopCount = 0 then
			Response.Write "<FONT size='2' face='Arial'>No Settings Available</Font>"	
		end if
	
	Response.Write "</TD></TR></TABLE>"
	
		if ModLoopCount > 0 then
			'Response.Write "<hr color='#004182' width='100%'>"
			Response.Write "<br><input type='submit' value='Update Server' name='SetMod'>"
		end if
	
%>
	


</TD>
</TR>
</FORM>
</TABLE>



<%
	end if
%>

<% ' ---------End Mod Admin --------- %>


</TD>


<% ' ---------Begin Administration--------- %>

<TD width="45%" bgcolor="#003366" valign=top><center>
<form method="POST" action="update_quake3.asp">
<INPUT TYPE="HIDDEN" NAME="gamename" value="<%=gamename%>">
<INPUT TYPE="HIDDEN" NAME="quakemap_old" value="<%=mapname%>">
<INPUT TYPE="HIDDEN" NAME="g_gametype_old" value="<%=g_gametype%>">
<INPUT TYPE="HIDDEN" NAME="timelimit_old" value="<%=timelimit%>">
<INPUT TYPE="HIDDEN" NAME="capturelimit_old" value="<%=capturelimit%>">
<INPUT TYPE="HIDDEN" NAME="fraglimit_old" value="<%=fraglimit%>">
<INPUT TYPE="HIDDEN" NAME="sv_maxclients_old" value="<%=sv_maxclients%>">
<INPUT TYPE="HIDDEN" NAME="sv_allowdownload_old" value="<%=sv_allowdownload%>">
<INPUT TYPE="HIDDEN" NAME="g_teamForceBalance_old" value="<%=g_teamForceBalance%>">
<INPUT TYPE="HIDDEN" NAME="g_friendlyfire_old" value="<%=g_friendlyfire%>">
<FONT size=2 face="Arial">
Map: <select size="1" name="quakemap">
<OPTION Value="bq_other">---(other)---</OPTION>

<%
	while NOT OS.EOF

	if NOT temp_gametype2 = OS("gametype") then
	
		Response.Write "<OPTION Value='bq_other'> </OPTION>"
		Response.Write "<OPTION Value='bq_other'>---( " & OS("gametype") & " )---</OPTION>"
	
		temp_gametype2 = OS("gametype")
	
	end if

		response.write "<option value='" & OS("mapQName") & "'"

		if OS("mapQName") = mapname then
			response.write " selected"
		end if

		response.write ">"


		if Len(OS("mapName")) > 21 then

			response.write Left(OS("mapName"), 18) & "..."
		else

			response.write OS("mapName")
		end if


		response.write "</option>"

	OS.MoveNext
	
	
	WEND

%>

  </select>
<BR>
<TABLE width="100%" border=0 cellspacing=5 cellpadding=0><TR><TD align="right">
<a href='JavaScript:OpenWindow("maplist_quake3_small.asp<%=gametype%>&fs_game=<%=fs_game%>&gamename=<%=gamename%>")'><IMG SRC="../images/choosemap.gif" border="0"></A>
</TD><TD>
<a href='addmap.asp' target='editmaps'><IMG SRC="../images/editmaps.gif" border="0"></A>
</TD></TR></TABLE>

Game: <select size="1" name="g_gametype">
	<option value="">--(other)--</option>
    <option value="0" <% if g_gametype=0 then response.write "selected" %>>Free For All</option>
    <option value="1" <% if g_gametype=1 then response.write "selected" %>>Tournament 1-on-1</option>
    <option value="2" <% if g_gametype=2 then response.write "selected" %>>Single-Player</option>
    <option value="3" <% if g_gametype=3 then response.write "selected" %>>Team Deathmatch</option>
    <option value="4" <% if g_gametype=4 then response.write "selected" %>>Capture the Flag</option>
  </select>



<TABLE border=0 cellspacing=3 cellpadding=0>
<TR>
<TD align="right"><FONT size=1 face="Arial">Time Limit:</FONT></TD><TD><input type="text" name="timelimit" size="2" value="<%=timelimit%>"></TD>
<TD align="right"><FONT size=1 face="Arial">Capture Limit:</FONT></TD><TD><input type="text" name="capturelimit" size="2" value="<%=capturelimit%>"></TD>
</TR>
<TR>
<TD align="right"><FONT size=1 face="Arial">Frag Limit:</FONT></TD><TD><input type="text" name="fraglimit" size="2" value="<%=fraglimit%>"></TD>
<TD align="right"><FONT size=1 face="Arial">Max Clients:</FONT></TD><TD><input type="text" name="sv_maxclients" size="2" value="<%=sv_maxclients%>"></TD>
</TR>
</TABLE>

<TABLE border=0 cellspacing=2 cellpadding=0>
<TR>
<TD align="right"><FONT size=1 face="Arial">Allow Download:</FONT></TD><TD><input type="checkbox" name="sv_allowdownload" value="checked" <% if sv_allowdownload = 1 then response.write "checked" %>></TD>
<TD align="right"><FONT size=1 face="Arial">Team Balance:</FONT></TD><TD><input type="checkbox" name="g_teamForceBalance" value="checked" <% if g_teamForceBalance = 1 then response.write "checked" %>></TD>
</TR>
<TR>
<TD align="right"><FONT size=1 face="Arial">Friendly Fire:</FONT></TD><TD><input type="checkbox" name="g_friendlyfire" value="checked" <% if g_friendlyfire = 1 then response.write "checked" %>></TD>
<TD align="right"><FONT size=1 face="Arial"></FONT></TD><TD></TD>
</TR>
</TABLE>


</FONT>

<br>
<input type="submit" Name="S" value="Update Server">

<hr color='#004182' width='100%'>
<BR>
<%
	if session("map_restart") = 1 then

		response.write "<TABLE border=1 cellspacing=0 cellpadding=1 bordercolor='#FFFF00'><TR><TD>"
		response.write "<input type='submit' Name='restartmap' value='Restart Map'>"
		response.write "</TD></TR></TABLE>"
		session("map_restart") = 0
	else
		response.write "<input type='submit' Name='restartmap' value='Restart Map'>"
	end if

%>
<BR><BR>




</TD></TR>
<TR><TD bgcolor="#00104F" colspan="2" align="center">

<TABLE border=0 cellspacing=0 cellpadding=0 width="100%"><TR>
<TD align="left"><FONT size=1 face="Arial">Server Version: <%=version%></FONT></TD>
<TD align="right"><FONT size=1 face="Arial">Auto Refresh: <%=AutoRefreshHTML%></FONT></TD>
</TR></TABLE>

</TD></TR>

</TABLE>

</TD></TR></TABLE>

<% ' ---------End Administration--------- %>

<!--
<TABLE width="550" border="1" bordercolor="#004182" cellspacing="0" cellpadding="2">
<TR><TD bgcolor="#0052A4"><FONT size="2" face="Arial"><B>Send Message to Players</B></FONT></TD>
</TR>
<TR><TD align="center" bgcolor="#003366"><input type="text" name="message" size="74"> <input type="submit" Name="M" value="Send"></TD>
</TR>
</TABLE>

<BR>
-->




</form>
<BR><BR>

<A HREF="http://www.planetquake.com/bqserver" target="_blank"><IMG SRC="../images/bqserverlogo.gif" border="0"></A>
<BR>
<FONT size="1" face="Arial">
Please visit the <A HREF="http://www.planetquake.com/bqserver" target="_blank">BQServer Web Site</A> if you have any questions.
</FONT>

<BR><BR>
<FONT size="1" face="Arial">BQServer was developed by Brian Taylor 2001, for non-commercial uses. All rights reserved.</FONT>

</BODY>
</HTML>